#define ALLOCATE_EXTERN // Allocate explicit register addresses here
#include "Fx2.h"
#include "Fx2regs.h"
#include "swuart.h"
//#include <stdio.h>

typedef   signed long   int32_t;
typedef unsigned long  uint32_t;
typedef   signed short  int16_t;
typedef unsigned short uint16_t;
typedef   signed char   int8_t;
typedef unsigned char  uint8_t;

#define TIMER_RUNNING (TCON&0x10)

static volatile uint8_t t0_ovfl = 0;


void send1(void)
{
		EA=0;
#pragma asm
		mov IOA, #000h
		mov OEA, #020h
		mov OEA, #000h
		mov r2,#5
send1_loop:
		djnz r2,send1_loop
#pragma endasm
		EA=1;
}

void send0(void)
{
		EA=0;
#pragma asm
		mov IOA, #000h
		mov OEA, #020h
		mov r2,#8
send0_loop:
		djnz r2,send0_loop
		mov OEA, #000h
#pragma endasm
		EA=1;
}

void usleep(uint16_t us)
{
	us = us;
	us = us+(us/128)*14;
	us-=11;
	while(us--);
}

void timer0(void) interrupt 1
{
	TR0 = 0; // stop timer0
}

// max 16383 us
void StartTimer(uint16_t us)
{
	EA=0;
	TR0=0;
	//TCON=0;
	CKCON |= 0x08;
	//TMOD &= ~0x0F;
	//TMOD |= 0x01; // 16 bit timer

//	us = 0xFFFF-((us-5)<<2)+3;
//	us = 0x8F00;
//	us = 0xFFDB;

	// us*4 = us<<2
	//TL0 = us<<2;
	//TH0 = us>>6;

	TL0 = us&0xFF;
	TH0 = us>>8;

	//PT0=0; // set timer0 interrupt

	ET0=1; // enable timer0 interrupt
	TR0=1; // start timer0
	//TCON=0x10; // start timer0
	EA=1; // enable all interrupts
}

// max 16383 us
void StartTimerValue(uint16_t us)
{
	EA=0; // disable all interrupts
	TR0=0; // stop timer
	CKCON |= 0x08; // timer0 83,333ns resolution

	TL0 = us&0xFF;
	TH0 = us>>8;

	ET0=1; // enable timer0 interrupt
	TR0=1; // start timer0
	EA=1; // enable all interrupts
}



 uint8_t TimerElapsed()
{
	if (TCON&0x20)
		return 1;
	return 0;
}


void swim_entry(void)
{
	uint8_t i=0;
	uint16_t timerval;

	//(1)
	// 16us Low
	OEA = 0x20;
	usleep(16);
	//OEA = 0x00;

	_putchar_slow(i);
	//(2)
	for(i=0; i<4; i++)
	{
		//500us High
		OEA = 0x00;
		usleep(500);

		//500us Low
		OEA = 0x20;
		usleep(500);
		_putchar_slow(i);
	}

	for(i=0; i<4; i++)
	{
		//250us High
		OEA = 0x00;
		usleep(250);
	
		//250us Low
		OEA = 0x20;
		usleep(250);
	}

	OEA = 0x00;


	StartTimerValue(0);
	while((IOA&0x20) && TIMER_RUNNING)
	{
		_putchar_slow(0x00);
		_putchar_slow(TH0);
		_putchar_slow(TL0);
	}

	_putchar_slow(0x03);

	StartTimerValue(0);

#pragma asm
	nop
	nop
#pragma endasm

	/*
	while((IOA&0x20)==0 && TIMER_RUNNING)
	{
		_putchar_slow(0x01);
		_putchar_slow(TH0);
		_putchar_slow(TL0);
	}

	timerval = (TH0 << 8 | TL0);
	_putchar_slow(0x04);
	_putchar_slow(TH0);
	_putchar_slow(TL0);
	*/
	
}

main ()
{
	CPUCS = 0x12; // set CPU to 48 MHz
//	__asm mov CPUCS, #000h
	IOA = 0x00; // set Port A to LOW

	//InitTimer();
	init_uart();

	StartTimer(0);

	send1();
	send0();
	swim_entry();

	while(1);
	return;
}
